/*
   Test AFreadData

   $Id: tAFreadData.c 1.3 1999/06/04 libtsp-v5r6 $
*/

#include <libtsp.h>

#define MINV(a, b)	(((a) < (b)) ? (a) : (b))

#define NBUF	2560


int
main (int argc, const char *argv[])

{
  AFILE *AFp;
  int status;
  long int Nsamp, Nchan, ioffs, Nrem;
  int Nv, Nr;
  float Sfreq;
  char Fname[FILENAME_MAX];
  float X[NBUF];


/* Parameters for raw files */
  status = AFsetNHpar ("$AF_NOHEADER");
  if (status)
    UThalt ("tAFreadData: Error return from AFsetNHpar");
  status = AFsetFileType ("$AF_FILETYPE");
  if (status)
    UThalt ("tAFreadData: Error return from AFsetFileType");

/* Default search path */
  FLpathList (argv[1], "$AUDIOPATH", Fname);

/* Open the file */
  AFp = AFopenRead (Fname, &Nsamp, &Nchan, &Sfreq, stdout);

/* Read the data */
  ioffs = 0L;
  Nrem = Nsamp;
  while (Nrem > 0L) {
    Nv = (int) MINV (Nrem, NBUF);
    Nr = AFreadData (AFp, ioffs, X, Nv);
    ioffs += Nv;
    Nrem -= Nv;
  }
  printf ("tAFreadData: Total samples: %ld\n", ioffs);

/* Close the file */
  AFclose (AFp);

  return 0;
}
