/*
   Test AFwriteData

   $Id: tAFwriteXX.c 1.14 2001/09/26 libtsp-v5r6 $
*/

#include <libtsp.h>
#include <libtsp/AFpar.h>

#define N	12


int
main (int argc, const char *argv[])

{
  AFILE *AFp;
  int Format;
  long int Nsamp, Nchan;
  float Sfreq;
  float xi[N+2];
  struct AF_opt *AFopt;
  static float xo[N] = {30., 40., 60., -10., -40.,
			80., 60.25, -90.25, 32000., -32000., 33000., -33000.};

  sscanf (argv[2], "%d", &Format);
  sscanf (argv[3], "%ld", &Nchan);
  sscanf (argv[4], "%g", &Sfreq);
  AFopt = AFoptions ();
  if (argc > 5)
    sscanf (argv[5], "%d", &(AFopt->NbS));
  if (argc > 6)
    AFsetSpeaker (argv[6]);

  AFsetHinfo ("\ntitle: Test file");
  AFp = AFopenWrite (argv[1], Format, Nchan, (double) Sfreq, stdout);
  AFwriteData (AFp, xo, N) ;
  AFclose (AFp) ;

  AFsetNHpar ("text");	/* Assume text file for no header files */
  AFp = AFopenRead (argv[1], &Nsamp, &Nchan, &Sfreq, stdout);
  /* Read several times to test random access */
  /* File samples:  0 1 2 3 4 5 6 7      (shown for N = 8)
     (1) samples -1 0 1 2 3 4 5 6 7 8 9  === -1 to N+1, total N+2 samples
     (2) samples        2 3 4 5 6 7      === 2 to N-1, total N-2 samples
     (3) samples          3 4            === 3 to 4, total 2 samples
     (4) samples                6 7      === 6 to 7, total 2 samples
  */
  AFreadData (AFp, -1L, xi, N+2);
  AFreadData (AFp, 2L, &xi[3], N-2);
  AFreadData (AFp, 3L, &xi[4], 2);
  AFreadData (AFp, 6L, &xi[7], 2);
  AFclose (AFp);

  VRfPrint (stdout, "Readback data:", xi, N+2);

  return 0;
}
