/*
   Test window generation routines

   $Id: tFIxWinXXX.c 1.7 2002/03/25 libtsp-v5r6 $
*/

#include <string.h>

#include <libtsp.h>

#define NMAX 300


int
main (int argc, const char *argv[])

{
  int N, Nadv;
  float fWin[NMAX];
  double dWin[NMAX];
  const char *w;
  double a, T1, T2, T3;
  char *h;

  h = "Error";
  w = argv[1];
  sscanf (argv[2], "%d", &N);
  if (strcmp (w, "FIdWinHamm") == 0) {
    sscanf (argv[3], "%lg", &a);
    FIdWinHamm (dWin, N, a);
    h = "FIdWinHamm: generalized Hamming window";
  }
  else if (strcmp (w, "FIfWinRCos") == 0) {
    sscanf (argv[3], "%d", &Nadv);
    FIfWinRCos (fWin, N, Nadv);
    h = "FIfWinRCos: Raised Cosine window:";
  }
  else if (strcmp (w, "FIfWinHamm") == 0) {
    sscanf (argv[3], "%lg", &a);
    FIfWinHamm (fWin, N, a);
    h = "FIfWinHamm: generalized Hamming window:";
  }
  else if (strcmp (w, "FIfWinKaiser") == 0) {
    sscanf (argv[3], "%lg", &a);
    FIfWinKaiser (fWin, N, a);
    h = "FIfWinKaiser: Kaiser window:";
  }
  else if (strcmp (w, "FIfWinHCos") == 0) {
    sscanf (argv[3], "%lg", &a);
    T2 = N * 200./240.;
    T1 = T2 - 0.5;
    T3 = N - 0.25;
    FIfWinHCos (fWin, T1, T2, T3, a);
    h = "FIfWinHCos: Hamming/Cosine window:";
  }
  else
    UThalt ("tFIxWinXXX: Invalid window code");

  if (h[2] == 'f')
    VRfPrint (stdout, h, fWin, N);
  else
    VRdPrint (stdout, h, dWin, N);

  return 0;
}
