/*-------------- Telecommunications & Signal Processing Lab ---------------
                             McGill University

Routine:
  void VRdLinInc (double xmin, double xmax, double x[], int N)

Purpose:
  Generate a linearly spaced array of values

Description:
  This routine generates a linearly spaced array of values
    y[i] = xmin + i*(xmax-xmin)/(N-1),  0 <= i < N.

Parameters:
   -> double xmin
      Minimum value
   -> double xmax
  <-  double x[]
      Array of doubles (N elements)
   -> int N
      Number of elements

Author / revision:
  P. Kabal  Copyright (C) 2002
  $Revision: 1.1 $  $Date: 2002/02/15 02:33:41 $

-------------------------------------------------------------------------*/

static char rcsid[] = "$Id: VRdLinInc.c 1.1 2002/02/15 libtsp-v5r6 $";

#include <libtsp.h>


void
VRdLinInc (double xmin, double xmax, double x[], int N)

{
  int i;
  double dx;

  /* Make sure output includes xmin and xmax, exactly */
  if (N > 0) {
    x[0] = xmin;
    dx = (xmax - xmin) / (N-1);
  }
  for (i = 1; i < N-1; ++i)
    x[i] = xmin + i * dx;

  if (N > 1)
    x[N-1] = xmax;

  return;
}
